require 'ming/ming'
include Ming

require 'kconv'

use_SWF_version(6)

def board
  s = SWFShape.new
  s.set_line(4, 0x00, 0x00, 0x00)
  for i in 0...7
    s.move_pen_to(-150+i*50, -150)
    s.draw_line_to(-150+i*50, 150)
    s.move_pen_to(-150, -150+i*50)
    s.draw_line_to(150, -150+i*50)
  end
  s.move_pen_to(-125, -125-10)
  s.draw_line_to(-125, -125+10)
  s.move_pen_to(-125, -125-10)
  s.draw_line_to(-125+10, -125)
  s.move_pen_to(-125, -125-10)
  s.draw_line_to(-125-10, -125)

  s.move_pen_to(125, -125-10)
  s.draw_line_to(125, -125+10)
  s.move_pen_to(125, -125-10)
  s.draw_line_to(125+10, -125)
  s.move_pen_to(125, -125-10)
  s.draw_line_to(125-10, -125)

  s.move_pen_to(-125, 125+10)
  s.draw_line_to(-125, 125-10)
  s.move_pen_to(-125, 125+10)
  s.draw_line_to(-125+10, 125)
  s.move_pen_to(-125, 125+10)
  s.draw_line_to(-125-10, 125)

  s.move_pen_to(125, 125+10)
  s.draw_line_to(125, 125-10)
  s.move_pen_to(125, 125+10)
  s.draw_line_to(125+10, 125)
  s.move_pen_to(125, 125+10)
  s.draw_line_to(125-10, 125)

  s
end

def button_shape(label, c)
  s = SWFShape.new
  s.set_line(3, 0x00, 0x00, 0x00)
  s.set_right_fill(s.add_fill(c[0], c[1], c[2]))
  s.move_pen_to(-10, -22)
  s.draw_line_to(10*label.size+10, -22)
  s.draw_line_to(10*label.size+10, 10)
  s.draw_line_to(-10, 10)
  s.draw_line_to(-10, -22)
end

def button_text(label)
  t = SWFText.new()
  t.set_font(SWFFont.new("./Kochi Gothic.fdb"))
  t.set_color(0x00, 0x00, 0x00)
  t.set_height(20)
  t.add_UTF8_string(label, [1,1,1,1,1,1])
  t
end

def str_button(label, script)
  bp = SWFMovieClip.new

  t = button_text(label)
  b = SWFButton.new
  b.add_shape(button_shape(label, [0xdd, 0xff, 0xdd]),
              SWFButton::HIT | SWFButton::UP | SWFButton::OVER)
  b.set_down(button_shape(label, [0xff, 0xdd, 0xdd]))
  b.add_shape(t, SWFButton::HIT | SWFButton::UP | SWFButton::DOWN | SWFButton::OVER)

  if (script)
    b.add_action(SWFAction.new(script), SWFButton::MOUSE_UP)
  end

  bp.add(b)
  bp.next_frame

  bp
end

def toggle_button(label, script1, script2)
  bp = SWFMovieClip.new

  cols = [[0xdd, 0xff, 0xdd], [0xff, 0xdd, 0xdd]]
  cols.each_index do |i|
    c = cols[i]
    s = button_shape(label, c)
    t = button_text(label)
    b = SWFButton.new
    b.add_shape(s, SWFButton::HIT | SWFButton::UP | SWFButton::DOWN | SWFButton::OVER)
    b.add_shape(t, SWFButton::HIT | SWFButton::UP | SWFButton::DOWN | SWFButton::OVER)

    if (i == 0)
      b.add_action(SWFAction.new("gotoAndStop(2); #{script1}"), SWFButton::MOUSE_UP)
    else
      b.add_action(SWFAction.new("gotoAndStop(1); #{script2}"), SWFButton::MOUSE_UP)
    end

    bp.add(b)
    bp.next_frame
  end

  bp
end

def init_button
  str_button("Init", "
    _global.lv.cmd = 'init';
    _global.lv.sendandload('geister.cgi', _global.lv);
  ")
end

def reload_button
  str_button("Reload", "
    _global.reload();
  ")
end

def autoreload_button
  toggle_button("Reload",
                "_global.autoReload = setInterval(_global.reload, 3000);",
                "clearInterval(_global.autoReload);")
end

def state_button
  bp = SWFMovieClip.new
  ['', 'Ԥ', 'Ԥ', '', '', '', ''].each do |msg|
    t = button_text(msg.toutf8)
    b = button_shape(msg, [0xdd, 0xff, 0xff])
    bp.add(b)
    bp.add(t)
    bp.next_frame
  end
  bp
end

def setup_button(p)
  str_button("Setup", "
    ok = true;
    for (i = #{p*8-8}; i < #{p*8}; i++) {
      if (_global.ghosts[i][0] < 1 || _global.ghosts[i][0] > 4 ||
          _global.ghosts[i][1] < #{p*4-4} || _global.ghosts[i][1] > #{p*4-3}) {
        ok = false;
        break;
      }
    }

    if (ok) {
      _global.lv.cmd = 'setup';
      _global.lv.p = #{p};
      _global.lv.sendandload('geister.cgi', _global.lv);
    }
  ")
end

def ghost_button(rc, gc, bc)
  s = SWFShape.new
  s.set_line(3, 0x00, 0x00, 0x00)
  s.set_right_fill(s.add_fill(rc, gc, bc))
  s.move_pen_to(15, 0)
  s.draw_line_to(-8, 13)
  s.draw_line_to(-8, -13)
  s.draw_line_to(15, 0)
  b = SWFButton.new
  b.add_shape(s, SWFButton::HIT | SWFButton::UP | SWFButton::DOWN | SWFButton::OVER)
end

def ghost_button_layout(rc, gc, bc)
  b = ghost_button(rc, gc, bc)
  b.add_action(SWFAction.new("
    this.startDrag();
    this.startX = this._x;
    this.startY = this._y;
  "), SWFButton::MOUSE_DOWN)
  b.add_action(SWFAction.new("
    this.stopDrag();

    var x = Math.floor(this._y/50);
    var y = Math.floor((this._x-10)/50);

    ok = true;
    if (x < 0 || y < 0 || x > 5 || y > 5) {
      ok = false;
    }
    else {
      for (i = 0; i < 16; i++) {
        if (x == _global.ghosts[i][0] && y == _global.ghosts[i][1]) {
          ok = false;
        }
      }
    }

    if (_root.player == 1) {
      if (y >= 3) {
        ok = false;
      }
    }
    else if (_root.player == 2) {
      if (y < 3) {
        ok = false;
      }
    }
    else {
      ok = false;
    }

    if (ok) {
      this._x = y*50+25;
      this._y = x*50+25+10;

      id = this._name.substr(1);

      _global.lv.cmd = 'move';
      _global.lv.id = id;
      _global.lv.x = x;
      _global.lv.y = y;
      _global.lv.sendandload('geister.cgi', _global.lv);

      _global.ghosts[id][0] = x;
      _global.ghosts[id][1] = y;
    }
    else {
      this._x = this.startX;
      this._y = this.startY;
    }
  "), SWFButton::MOUSE_UP | SWFButton::MOUSE_UP_OUTSIDE)

  b
end

def ghost_button_move(rc, gc, bc)
  b = ghost_button(rc, gc, bc)
  b.add_action(SWFAction.new("
    this.startDrag();
    this.startX = this._x;
    this.startY = this._y;
  "), SWFButton::MOUSE_DOWN)
  b.add_action(SWFAction.new("
    this.stopDrag();

    var x = Math.floor(this._y/50);
    var y = Math.floor((this._x-10)/50);

    id = this._name.substr(1);

    ok = true;
    if (x < 0 || y < 0 || x > 5 || y > 5) {
      ok = false;
    }
    else if (Math.abs(x-ghosts[id][0]) + Math.abs(y-ghosts[id][1]) != 1) {
      ok = false;
    }
    else {
      p = (id < 8) ? 0 : 8;
      for (i = p; i < p+8; i++) {
        if (x == _global.ghosts[i][0] && y == _global.ghosts[i][1]) {
          ok = false;
        }
      }
    }

    if (_root.player == 0) {
      ok = false;
    }

    if (ok) {
      this._x = y*50+25;
      this._y = x*50+25+10;

      _global.lv.cmd = 'move';
      _global.lv.id = id;
      _global.lv.x = x;
      _global.lv.y = y;
      _global.lv.sendandload('geister.cgi', _global.lv);

      _global.ghosts[id][0] = x;
      _global.ghosts[id][1] = y;
    }
    else {
      this._x = this.startX;
      this._y = this.startY;
    }
  "), SWFButton::MOUSE_UP | SWFButton::MOUSE_UP_OUTSIDE)

  b
end

def button_clip(b)
end

def ghost_act
  bp = SWFMovieClip.new
  bp.add(ghost_button(0xff, 0xff, 0xff))
  bp.next_frame
  bp.add(ghost_button_layout(0x00, 0x00, 0xff))
  bp.next_frame
  bp.add(ghost_button_layout(0xff, 0x00, 0x00))
  bp.next_frame
  bp.add(ghost_button_move(0x00, 0x00, 0xff))
  bp.next_frame
  bp.add(ghost_button_move(0xff, 0x00, 0x00))
  bp.next_frame
  bp.add(ghost_button(0x00, 0x00, 0xff))
  bp.next_frame
  bp.add(ghost_button(0xff, 0x00, 0x00))
  bp.next_frame
  bp
end

m = SWFMovieClip.new

i = m.add(board)
i.set_name('geister')
i.move_to(150, 160)

for i in 0...16
  m.add(ghost_act).set_name("g#{i}")
end

i = m.add(init_button)
i.set_name('init')
i.move_to(130,340)

i = m.add(autoreload_button)
i.set_name('reload')
i.move_to(230,340)

i = m.add(state_button)
i.set_name('stat_info')
i.move_to(10, 340)

i = m.add(setup_button(1))
i.set_name('setup1')
i.move_to(-70,160)

i = m.add(setup_button(2))
i.set_name('setup2')
i.move_to(320,160)

m.next_frame

rm = SWFMovie.new
rm.set_dimension(500, 340)

i = rm.add(m)
i.set_name('root')
i.move_to(100, 0)
i.add_action(SWFAction.new("
  init.stop();
  setup1.stop();
  setup2.stop();
  reload.stop();
  stat_info.stop();

  _global.noticeSound = new Sound();
  _global.noticeSound.loadSound('item.mp3', false);

  _global.lv = new LoadVars();
  var m = this;
  m['setup1']._visible = false;
  m['setup2']._visible = false;
  _global.ghosts = new Array(16);
  _global.lv.onLoad = function(ok) {
    _global.state = parseInt(_global.lv.state);
    m.stat_info.gotoAndStop(_global.state+1);

    if (_global.prevState != _global.state &&
       ((_global.state == 3 && _root.player == 1) ||
        (_global.state == 4 && _root.player == 2)))
    {
      _global.noticeSound.start();
    }

    _global.prevState = _global.state;

    m['setup1']._visible =
      (_global.state == 0 || _global.state == 2) && _root.player == 1;
    m['setup2']._visible =
      (_global.state == 0 || _global.state == 1) && _root.player == 2;

    for (i = 0; i < 16; i++) {
      n = 'g' + i;
      p = _global.lv[n].split(',');
      m[n]._x = parseInt(p[1]) * 50 + 25;
      m[n]._y = parseInt(p[0]) * 50 + 25 + 10;

      if (i >= 8) {
        m[n]._rotation = 180;
      }

      evil = ((i % 8) < 4) ? 0 : 1;

      m[n].gotoAndStop(1);

      if (p[1] < 0 || p[1] > 5) {
        m[n].gotoAndStop(6+evil);
      }
      else if (_global.state < 3) {
        if (_root.player == 1 && i < 8) {
          if (_global.state == 0 || _global.state == 2) {
            m[n].gotoAndStop(2+evil);
          }
          else {
            m[n].gotoAndStop(6+evil);
          }
        }
        else if (_root.player == 2 && i >= 8) {
          if (_global.state == 0 || _global.state == 1) {
            m[n].gotoAndStop(2+evil);
          }
          else {
            m[n].gotoAndStop(6+evil);
          }
        }
      }
      else if (_global.state < 5) {
        if (_root.player == 1 && i < 8) {
          if (_global.state == 3) {
            m[n].gotoAndStop(4+evil);
          }
          else {
            m[n].gotoAndStop(6+evil);
          }
        }
        else if (_root.player == 2 && i >= 8) {
          if (_global.state == 4) {
            m[n].gotoAndStop(4+evil);
          }
          else {
            m[n].gotoAndStop(6+evil);
          }
        }
      }
      else if (_global.state < 7) {
        m[n].gotoAndStop(6+evil);
      }

      _global.ghosts[i] = p;
    }
  };
  _global.reload = function() {
    _global.lv.cmd = 'query';
    _global.lv.load('geister.cgi');
  };
  _global.reload();
"), SWFAction::ONLOAD)

rm.save('geister.swf')
